
# TAS 電話連線服務範例程式 - 互動式電話通告及取得 DTMF 數字按鍵輸入

HTTP POST callout API 輸入內容:
```
{
  "serviceNumber": "填入租用的服務代表號",
  "phones": [
    "填入被通知的電話號碼"
  ],
  "ivrData": {
    "node": "MAIN",
    "nextNode": "CUSTOM"
  }
}
```

配合附檔範例程式，以下是程式執行記錄， received msg 是程式收到的訊息， sent Msg 是程式送出的訊息：
```
broker = ssl://tasapi.cht.com.tw:2883
connecting MQTT broker...
connected
[calloutResult] received msg: {
  "id" : "5c239856;tw.voip.IoTIMS",
  "groupId" : "02XXXXXXXX.854b1488-7f55-4514-9c39-b8466ea146aa",
  "phone" : "02XXXXXXXX",
  "status" : "answered",
  "time" : "2022-04-06T02:05:48.846946240Z",
  "statusCode" : 200
}

[callEvent] received msg: {
  "id" : "5c239856;tw.voip.IoTIMS",
  "phone" : "02XXXXXXXX",
  "event" : "CallEstablished",
  "time" : "2022-04-06T02:05:48.860347901Z",
  "type" : "calloutEvent"
}

[callEvent] received msg: {
  "id" : "5c239856;tw.voip.IoTIMS.vS7",
  "phone" : "02XXXXXXXX",
  "node" : "MAIN",
  "time" : "2022-04-06T02:05:48.867987434Z",
  "type" : "calloutRequest"
}

sent msg: {
  "node": "askNode",
  "collectDTMFTimeout": "3",
  "maxDTMF": "1",
  "nextNode": "CUSTOM",
  "id": "5c239856;tw.voip.IoTIMS.vS7",
  "text": "您好，請問近期到阿明餐館的消費體驗，滿分5分，請問您給幾分評價",
  "promptMode": "F",
  "collectDTMF": true
}

[callEvent] received msg: {
  "id" : "5c239856;tw.voip.IoTIMS.qS7",
  "phone" : "02XXXXXXXX",
  "node" : "askNode,5",
  "time" : "2022-04-06T02:06:00.222370900Z",
  "type" : "calloutRequest"
}

input = 5
sent msg: {
  "node": "bye",
  "nextNode": "END",
  "id": "5c239856;tw.voip.IoTIMS.qS7",
  "text": "感謝您的評分，再見",
  "promptMode": "F"
}

[callEvent] received msg: {
  "id" : "5c239856;tw.voip.IoTIMS",
  "phone" : "02XXXXXXXX",
  "event" : "CallHangUp",
  "time" : "2022-04-06T02:06:04.695651585Z",
  "type" : "calloutEvent"
}
```

程式使用的外部函式庫，記載於 build.gradle 檔
使用下列函式庫：
* [JSON In Java](https://mvnrepository.com/artifact/org.json/json)
* [Eclipse Paho Client Mqttv3](https://mvnrepository.com/artifact/org.eclipse.paho/org.eclipse.paho.client.mqttv3)


程式可以使用 gradle 或 gradlew 執行，例如在 Windows 平台執行：
```
gradlew run
```

TAS API 詳細使用說明文件：
https://tasapi.cht.com.tw/tas/download/tas_api_20191109.pdf