plugins {
    java
    application
}

group = "tas.sample"
version = "0.1"

repositories {
    mavenCentral()
}

application {
    mainClass.set("tas_sample.CalloutMQTTSample")
}

tasks.withType<JavaCompile> {
//JDK version 10+ can use "release" flag
//    options.release.set(8)
    if (JavaVersion.current().isJava10Compatible) {
        options.release.set(8)
    } else {
        sourceCompatibility = "1.8"
        targetCompatibility = "1.8"
    }

    options.encoding = "UTF-8"
    options.compilerArgs = listOf(
        "-Xlint:deprecation",
        "-Xlint:unchecked"
    )
}

//專案所使用的外部函式庫，將透過 gradle 工具下載
dependencies {
    //JSON 訊息解析函式庫
    implementation("org.json:json:20231013")
    //MQTT 連線函式庫
    implementation("org.eclipse.paho:org.eclipse.paho.client.mqttv3:1.2.5")
}